<?

# SLP Helper multicast-to-unicast proxy (C) Alex/AT (alex@alex-at.ru), 2012
# Free to distribute. Do not remove above string. Sale or rental of this or derivative is prohibited.

define('SOCKET_TIMEOUT', 15);

$unicast_ips = array('192.168.1.1');

echo('SLP Helper starting. No errors must follow this line.'."\n");
echo('Using Unicast IPs:'."\n".implode(', ', $unicast_ips)."\n");

$rcv = socket_create(AF_INET, SOCK_DGRAM, SOL_UDP);
socket_set_option($rcv, SOL_SOCKET, SO_BROADCAST, 1);
socket_set_option($rcv, SOL_SOCKET, SO_REUSEADDR, 1);
socket_bind($rcv, '0.0.0.0', 427);
socket_set_option($rcv, IPPROTO_IP, IP_MULTICAST_LOOP, 1);
socket_set_option($rcv, IPPROTO_IP, MCAST_JOIN_GROUP, array('group' => '239.255.255.253', 'interface' => 0));
socket_set_nonblock($rcv);

$sskts = array();

while (TRUE)
{
    # request
    $buf = ''; $from = ''; $ip = ''; $port = 0;
    if (($len = @socket_recvfrom($rcv, $buf, 0x10000, 0, $ip, $port)) !== FALSE)
    {
        echo('Received request from '.$ip.':'.$port.' of length '.$len.".\n");

        # check, if we have socket assigned
        if (isset($sskts[$ip.':'.$port]))
        {
            $snd = $sskts[$ip.':'.$port]['socket'];
        }
        else
        {
            # assign new socket
            echo('Assigning socket to '.$ip.':'.$port.".\n");

            $sskts[$ip.':'.$port] = array(
                'ip' => $ip,
                'port' => $port,
                'timeout' => time() + SOCKET_TIMEOUT,
                'socket' => socket_create(AF_INET, SOCK_DGRAM, SOL_UDP),
            );

            $snd = $sskts[$ip.':'.$port]['socket'];
            socket_set_option($snd, SOL_SOCKET, SO_BROADCAST, 1);
            socket_bind($snd, '0.0.0.0', 0);
            socket_set_nonblock($snd);
        }

        foreach ($unicast_ips as $tip)
        {
            echo('Transmitting request from '.$ip.':'.$port.' of length '.$len.' to '.$tip.".\n");
            socket_sendto($snd, $buf, $len, 0, $tip, 427);
        }
    }

    # responses
    foreach ($sskts as $ski => $skd)
    {
        $rsp = $skd['socket'];

        $buf = ''; $from = ''; $port = 0;
        if (($len = @socket_recvfrom($rsp, $buf, 0x10000, 0, $ip, $port)) !== FALSE)
        {
            echo('Received response from '.$ip.':'.$port.' of length '.$len.".\n");
            echo('Transmitting response from '.$ip.':'.$port.' of length '.$len.' to '.$skd['ip'].':'.$skd['port'].".\n");
            socket_sendto($rcv, $buf, $len, 0, $skd['ip'], $skd['port']);
        }

        if ($skd['timeout'] < time())
        {
            echo('Destroying socket for '.$ski.' because of timeout.'."\n");
            socket_close($rsp);
            unset($sskts[$ski]);
        }
    }

    # sleep a bit
    usleep(50000);
}

?>